import java.awt.Color;
import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class ColorParticle here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ColorParticle extends Actor
{

    private Color myColor;
    private GreenfootImage image;

    private int speed;
    private int mySize;
    private int myMouseColor;
    /**
     * Act - do whatever the ColorParticle wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public ColorParticle(int newSpeed, int newDirection, int mouseColor)
    {
        myMouseColor = mouseColor;
        if (myMouseColor == 0)
        {
            myColor = new Color(200,0,0);
        }
        else
        if (myMouseColor == 1)
        {
            myColor = new Color(0,200,0);
        }
        else
        if (myMouseColor == 2)
        {
            myColor = new Color(0,0,200);            
        }
        speed = newSpeed;
        setRotation(newDirection);
        image = new GreenfootImage(200,200);

        setImage(image);
        mySize = 1;
    }

    public void act() 
    {
        mySize++;
        move(speed);
        fade(myMouseColor);
        if (atWorldEdge() || (myColor.getRed() < 10
            && myColor.getBlue() < 10
            && myColor.getGreen() < 10))
        {
            getWorld().removeObject(this);
        }
    }    

    public void fade(int whichColor)
    {
        int r = myColor.getRed();
        int g = myColor.getGreen();
        int b = myColor.getBlue();
        if (whichColor == 0)
        {
            if (r >= 10)
            {
                r-=3;
            }
            else
            {
                r = 0;

            }
            if (whichColor == 1)
            {
                if  (g >= 10)
                {
                    g-= 3;
                }
                else
                {
                    g = 0;
                }
            }
            if (whichColor == 2)
            {
                if (b >= 10)
                {
                    b -= 3;
                }
                else
                {
                    b = 0;
                }
            }
            myColor = new Color(r,b,g);
            image.setColor(myColor);
            image.fillOval(100 - mySize / 2 , 100 - mySize / 2 ,mySize,mySize);
            }
        }

        public boolean atWorldEdge()
        {
            if(getX() < 10 
            ||getY() < 19     
            || getX() > getWorld().getWidth() - 2
            ||getY() > getWorld().getHeight() - 2)
            {
                return true;
            }   
            else
            {
                return false;
            }
        }    

    }
